%% \documentclass[10pt,a4,twocolumn]{article}
%% \usepackage{varioref}
%% \title{Reflections on the communication algorithms\\Rev. 2}
%% \author{Tobias Nielsen}
%% \date{\today}

%% \def\todo#1{{\footnotesize \bf Todo: #1}}
%% \begin{document}
%% \maketitle
%% \tableofcontents
\section{The module in its own universe}
\begin{quote}
  A priori knowledge. (what do i need to define about the
  modules before describing its social abilities?)
\end{quote}

%% Pack, herd and swarm grouping.

\subsection{Defining the different communication forms}
\label{sec:def_diff_com_forms}


\subsection{Communication methods already known}

\section{A framework}
\subsection{Defining a framework}
Before going in to debating all the ``hows'' and ``whats'', A
definition of the word \emph{Framework} needs to be laid out.

Actually there is not many that has come to complete congruence to the
definition of the term \emph{Framework}, but instead many have an
opinion to what it includes. However \emph{Wikipedia.org} gives the following
definition of the two terms:
\begin{quote}
\begin{description}
\item[Conceptual framework] is used in research to outline possible
  courses of action or to present a preferred approach to an idea or
  thought.
\item[Software framework] is a reusable design for a software system
  (or subsystem). A software framework may include support programs,
  code libraries, a scripting language, or other software to help
  develop and glue together the different components of a software
  project. Various parts of the framework may be exposed through an
  API.
\end{description}
\end{quote}

The eCos operating system, is a very good example of such a framework
since it provides both the system to be downloaded to the
microprocessor and also the tools available to handle the
configuration and compilation of the operating system. In the
communication situation, the framework is more a library providing a
basic API for handling the communication.

\subsection{Modular framework}
Since the world of artificial intelligence is continuously shifting
and always finding new approaches on how to solve problems, it is not
trivial to choose which items to include in a first ideological
framework. Establishing a common representation of communication is a
good way to begin designing a framework that utilizes approach to
local and global communication. But as in the Internet, the hardware
platform is often changing making it impossible to create a software
package that will work on all platforms. The approach often applied in
the Internet is to use a sophisticated protocol stack that at the very
highest level, gives a generic approach to network communication. It
is in this structure possible to scrape of layers of protocols. But
each time such a layer is removed, it is important to bare in mind
what the layers that are below you provides - and more important, what
they don't provide! Another thing with the Internet is that it has a
lot of different users with very different needs. Most of these
users/applications care only about what is provided by the end
terminals of the network (the application running at the other end of
the wire). How the information is moved forth and back is less
important and rarely provides any information of any use to the
application.

In the case of the typical modular robot, the decoupling level between
the hardware and the applications running on top of them, is not as
high as seen in the Internet. In the Internet the motivating part is
the ability for the hardware to comply the rules that the software has
laid out. In modular robotics, the abilities with different hardware
approaches yields new possibilities together with constraints for the
software. This makes protocol design a more complex task from a
generic point of view.

But if the generic perspective for \emph{all} modular robots is put
aside, it is off course possible to design a framework that gives a
common working set for a specific module robot.

\subsection{The Odin variant}
In the case with the Odin robot, it is not possible to achieve
orientation information directly through local communication since the
node allows attaching a module in 12 different orientated points
connected to the same physical communication wire.  So in order to
find out how the modules are orientated with respect to each other, a
special method (ex. accelerometers) must be invented and applied.

Demands for a communication framework for modular robots

\begin{description}
\item[Robustness] When routing messages through the network, there is
  a risk that the topology is changed due to reconfiguration, module
  failure or simply package loss. The network should be able to
  automatically reevaluate the net so a new path will be created
  whenever there is a need for it.
\item[Module emergence and disappearance] When a module is connected
  or removed from a node, the neighbors must be informed accordingly.
\end{description}

So the methods supported by the framework should be:
\begin{description}
\item[Node communication] The node communication supports
  communication with the directly connected neighbors. It is the same
  kind of communication that handles appearance and disappearance of
  modules on a node. The form that is applied here will help telling
  which modules is directly attached as a neighbor and provide both
  direct peer to peer communication to the members and at the same
  time support being able to broadcast to all the locally connected
  neighbors.

\item[Global communication] It is the purpose for a global
  communication network to support sending data to all the members in
  the robot without having to worry about unwanted loops in the
  communication configuration. It is desirable to be able to support
  changes in the topology with any non local communication
  scheme. (not only the global communication scheme)

\item[Routed communication]
  In this system a message is sent through the robot grid ending up at
  a dedicated end module. The path that the message follows, may
  randomly alter itself based on configuration and congestion of the
  robots net.

\item[Hybrid communication] The Hybrid communication is an extension
  of the routed communication method. Modules that have a specific
  need for high speed communication, may choose to enter such a
  communication state which gives a kind of communication that
  resembles local communication - just between distant modules. 
\end{description}
% Selecting the things that needs to be in a framework.


\subsection{The architecture in the framework}

\todo{Make a data flow diagram for how the architecture is able to
  handle the approaches.}

\begin{description}
\item [Plug able approach]
\item [Layered approach]
\end{description}


%% influence on knowledge.
% local communication
% global communication
% hybrids of the two main types
% already known algorithm types
%% Routing algorithms DV and RV

%\end{document}
